#include "libgraph.h"
#include "image.h"
#include <memory.h>

static value gr_alloc_int_vect(size)
     mlsize_t size;
{
  value res;
  mlsize_t i;

  res = alloc_shr(size, 0);
/*
  if (size <= Max_young_wosize) {
    res = alloc(size, 0);
  } else {
    res = alloc_shr(size, 0);
  }
*/
  for (i = 0; i < size; i++) {
    Field(res, i) = Val_long(0);
  }
  return res;
}

value gr_dump_image(image)
     value image;
{
  int width, height, i, j;
  int col;
  XImage * idata, * imask;
  Push_roots(root, 2);

#define im root[0]
#define m root[1]

  gr_check_open();
  im = image;
  width = Width_im(im);
  height = Height_im(im);
#ifdef DEBUG_IMG
  fprintf(stderr,"Caml: dump_image: size %d %d.\n",width, height);
#endif

  m = gr_alloc_int_vect(height);
  for (i = 0; i < height; i++)
    modify(&Field(m, i), gr_alloc_int_vect(width));

  idata =
    XGetImage(grdisplay, Data_im(im), 0, 0, width, height, (-1), ZPixmap);
  for (i = 0; i < height; i++)
    for (j = 0; j < width; j++)
    {
      col=gr_rgb_pixel(XGetPixel(idata, j, i));
      Field(Field(m, i), j) = Val_int(col);
    }
  XDestroyImage(idata);

  if (Mask_im(im) != None) 
  {
#ifdef DEBUG_IMG
  fprintf(stderr,"Caml: dump_image: mask.\n");
#endif

    imask =
      XGetImage(grdisplay, Mask_im(im), 0, 0, width, height, 1, ZPixmap);
    for (i = 0; i < height; i++)
      for (j = 0; j < width; j++)
        if (XGetPixel(imask, j, i) == 0)
          Field(Field(m, i), j) = Val_int(Transparent);
    XDestroyImage(imask);
  }

  Pop_roots();
  return m;

#undef im
#undef m
}


    
