#include "libgraph.h"
#include <memory.h>

value gr_fill_rect(vx, vy, vw, vh)
     value vx, vy, vw, vh;
{
  int x = Int_val(vx);
  int y = Int_val(vy);
  int w = Int_val(vw);
  int h = Int_val(vh);

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_fill_rect: Validwin=%d; x,y,w,h=%d,%d,%d,%d\n", 
           ValidWindow, x, y, w, h);
#endif 

  if(ValidWindow==FALSE) return Val_unit;
  XFillRectangle(grdisplay, grwindows[current_window].win, 
	         grwindows[current_window].gc,
                 x, Wcvt(y) - h + 1, w, h);

  return Val_unit;
}

value gr_fill_poly(array)
     value array;
{
  XPoint * points;
  int npoints, i;

  if(ValidWindow==FALSE) return Val_unit;
  npoints = Wosize_val(array);
  points = (XPoint *) stat_alloc(npoints * sizeof(XPoint));
  for (i = 0; i < npoints; i++) {
    points[i].x = Int_val(Field(Field(array, i), 0));
    points[i].y = Wcvt(Int_val(Field(Field(array, i), 1)));
  }
  XFillPolygon(grdisplay, grwindows[current_window].win, 
	       grwindows[current_window].gc, points,
               npoints, Complex, CoordModeOrigin);
  stat_free(points);

  return Val_unit;
}

value gr_fill_arc(argv, argc)
     int argc;
     value * argv;
{
  int x = Int_val(argv[0]);
  int y = Int_val(argv[1]);
  int rx = Int_val(argv[2]);
  int ry = Int_val(argv[3]);
  int a1 = Int_val(argv[4]);
  int a2 = Int_val(argv[5]);

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_fill_arc: Validwin=%d; x,y,rx,ry=%d,%d,%d,%d\n", 
           ValidWindow, x, y, rx, ry);
#endif 

  if(ValidWindow==FALSE) return Val_unit;
  XFillArc(grdisplay, grwindows[current_window].win, 
           grwindows[current_window].gc,
           x - rx, Wcvt(y) - ry, rx * 2, ry * 2, a1 * 64, (a2 - a1) * 64);

  return Val_unit;
}
